﻿/* =========================================================================

InDesign ExtendScript

NAME: PrintSeparatedPS
VERSION: 1.0

AUTHOR: Vitaly Batushev
DATE  : 29.12.2003

DESCRIPTION:
Пополосная генерация ps-файлов.
Каждая полоса прописывается в отдельный файл с именем по схеме:
название документа + дефис + номер полосы + символ подчеркивания + метка цвета (c, m, y или k).
Например, mydocument-10_c.ps - 10 полоса публикации mydocument.indd, цвет Cyan

В скрипте частично использован код
скрипта MultiPrint Олега Бутрина (obutrin@indesign.rudtp.ru)

SUPPORT: http://indesign.rudtp.ru
E-MAIL: vbatushev@indesign.rudtp.ru

============================================================================ */
with (app)
{
	if (documents.length < 1)	{
		alert("Нет открытых документов!");
		exit();
	}
//Заполняем массив имен стилей печать	
	var myPrinterPresNames = new Array();
	var ips = 0;
	for (myCounter = 0; myCounter < printerPresets.length; myCounter++) {
	// Если у нас принтер Postscript
		if (printerPresets[myCounter].printer == 1886611052) {
			myPrinterPresNames[ips] = printerPresets[myCounter].name;
			ips++;
		}
	}

	if (myPrinterPresNames.length == 0) {
		alert("Не найдено ни одного стиля печати с принтером Postscript® File!");
		exit();
	}

	var myDoc = activeDocument;

 	var myDlg = dialogs.add({name:"Создать Separate Postscript из " + activeDocument.name});
	with (myDlg)	{
	//Создаем панель выбора стилей
	with (myDlg.dialogColumns.add()) {
		with (borderPanels.add().dialogColumns.add()) {
				with (dialogRows.add()) {
					with (dialogColumns.add()) {
						var myPrintPreset = staticTexts.add({staticLabel:"Стили печати"});
					}
					with (dialogColumns.add()) {
						var myPrinterPresSelect = dropdowns.add({stringList:myPrinterPresNames, selectedIndex:0, minWidth:173});
					}
				}
		}
		with (borderPanels.add().dialogColumns.add()) {
			with (dialogRows.add()) {
			with (dialogColumns.add()) {
			var pCyan = checkboxControls.add({staticLabel:"Печатать Cyan   ", checkedState:true});
			var pMagenta = checkboxControls.add({staticLabel:"Печатать Magenta   ", checkedState:true});
			}
			with (dialogColumns.add()) {
			var pYellow = checkboxControls.add({staticLabel:"Печатать Yellow  ", checkedState:true});
			var pBlack = checkboxControls.add({staticLabel:"Печатать Black", checkedState:true});
			}
			}
		}		
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				var mySelectPage = radiobuttonGroups.add();
				with (dialogRows.add()) {
					myPageSelect = mySelectPage.radiobuttonControls.add({staticLabel:"Страницы с", checkedState:false});
					myPageAll = mySelectPage.radiobuttonControls.add({staticLabel:"Все страницы", checkedState:true});
				}
			}
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
				var myStartPage = realEditboxes.add({editValue:1, minWidth:40});
				staticTexts.add({staticLabel:"по"});
				var myEndPage = realEditboxes.add({editValue:myDoc.pages.length, minWidth:40});
				}
			}
		}
 	}
	}
	var myResult = myDlg.show();
	if (myResult == false) {
		myDlg.destroy();
		exit();
	}
	
	var mySelectedFolder = Folder.selectDialog("Выбор папки", "~" );
	if (mySelectedFolder == null) {
		alert("Папка не выбрана!");
		exit();
	}

myDoc.printPreferences.activePrinterPreset = printerPresets.item(myPrinterPresNames[myPrinterPresSelect.selectedIndex]);
if (myPageSelect.checkedState == true) {
	for (ipage = myStartPage.editValue; ipage <= myEndPage.editValue; ipage++) {
		myDoc.printPreferences.pageRange = ipage.toString();
		result = printColors("-" + ipage);
	}
}
if (myPageAll.checkedState == true) {
	myDoc.printPreferences.pageRange = 1886547553; // All pages
	result = printColors("");
}
alert("Готово!");
}
function printColors(pagelabel)
{
	if (pCyan.checkedState == true) {
	 	var myFileC = new File(mySelectedFolder + "/" + getFileNameOnly(myDoc.name) + pagelabel + "_c.ps");
		myDoc.inks[0].printInk = true; // Печатаем голубой
		myDoc.inks[1].printInk = false; // Не печатаем пурпурный
		myDoc.inks[2].printInk = false; // Не печатаем желтый
		myDoc.inks[3].printInk = false; // Не печатаем черный
		myDoc.printPreferences.printFile = myFileC;
		myDoc.print(false);
	}
	if (pMagenta.checkedState == true) {
	 	var myFileM = new File(mySelectedFolder + "/" + getFileNameOnly(myDoc.name) + pagelabel + "_m.ps");
		myDoc.inks[0].printInk = false; // Печатаем голубой
		myDoc.inks[1].printInk = true; // Не печатаем пурпурный
		myDoc.inks[2].printInk = false; // Не печатаем желтый
		myDoc.inks[3].printInk = false; // Не печатаем черный
		myDoc.printPreferences.printFile = myFileM;
		myDoc.print(false);
	}
	if (pYellow.checkedState == true) {
	 	var myFileY = new File(mySelectedFolder + "/" + getFileNameOnly(myDoc.name) + pagelabel + "_y.ps");
		myDoc.inks[0].printInk = false; // Печатаем голубой
		myDoc.inks[1].printInk = false; // Не печатаем пурпурный
		myDoc.inks[2].printInk = true; // Не печатаем желтый
		myDoc.inks[3].printInk = false; // Не печатаем черный
		myDoc.printPreferences.printFile = myFileY;
		myDoc.print(false);
	}
	if (pBlack.checkedState == true) {
	 	var myFileK = new File(mySelectedFolder + "/" + getFileNameOnly(myDoc.name) + pagelabel + "_k.ps");
		myDoc.inks[0].printInk = false; // Печатаем голубой
		myDoc.inks[1].printInk = false; // Не печатаем пурпурный
		myDoc.inks[2].printInk = false; // Не печатаем желтый
		myDoc.inks[3].printInk = true; // Не печатаем черный
		myDoc.printPreferences.printFile = myFileK;
		myDoc.print(false);
	}
} 
//Функция удаляет все символы после последней точки в имени файла (удаляем расширение)
function getFileNameOnly (myFileName) {
	var myString = "";
	var myResult = myFileName.lastIndexOf(".");
	if (myResult == -1) {
		myString = myFileName;
	}
	else {
		myString = myFileName.substr(0, myResult);
	}
	return myString;
}